// OpenContainer.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <shlobj.h>
#include <shlwapi.h>
#include <shellapi.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	IShellLink *lpLink;
	IPersistFile *lpPersist;
	WCHAR wchBuf[MAX_PATH];
	TCHAR tchBuf[MAX_PATH];

	// Copy name, strip quotes
	if (lpCmdLine && lpCmdLine[0]==TEXT('\"'))
	{
		lstrcpy(tchBuf,lpCmdLine+1);
		tchBuf[lstrlen(tchBuf)-1]=0;
		lpCmdLine=tchBuf;
	}

	// Initialise COM
	CoInitialize(0);

	// Create link interface
	if (CoCreateInstance(CLSID_ShellLink,0,CLSCTX_INPROC_SERVER,IID_IShellLink,(LPVOID *)&lpLink)==S_OK)
	{
		// Query for IPersistFile interface
		lpLink->QueryInterface(IID_IPersistFile,(LPVOID *)&lpPersist);

		// Load shortcut
		MultiByteToWideChar(CP_ACP,0,lpCmdLine,-1,wchBuf,MAX_PATH);
		if (lpPersist->Load(wchBuf,STGM_READ)==NOERROR)
		{
			WIN32_FIND_DATA wfdData;
			TCHAR tchBuf[MAX_PATH];

			// Get path
			if (lpLink->GetPath(tchBuf,MAX_PATH,&wfdData,0)==NOERROR)
			{
				// Strip filename
				PathRemoveFileSpec(tchBuf);

				// Open the folder
				ShellExecute(0,TEXT("explore"),tchBuf,0,0,SW_SHOWNORMAL);
			}
		}

		// Free
		lpPersist->Release();
		lpLink->Release();
	}

	// Uninitialize COM
	CoUninitialize();
	return 0;
}



